package rocks.zipcode.quiz5.objectorientation.account;

import java.awt.*;
import java.util.ArrayList;

/**
 * @author leon on 27/12/2018.
 */
public class BankAccount extends Account implements Transactable{

    Double val;

    public BankAccount() {
        this.val = 0.0;
    }

    public void setBalance(Double val) {
        this.val = val;
    }

    @Override
    public void deposit(Double amountToIncreaseBy){
        try {
            if(val >= amountToIncreaseBy && amountToIncreaseBy > 0) {
                val += amountToIncreaseBy;
            }else{
                throw new IllegalArgumentException();
            }
        }catch (IllegalArgumentException e){
            System.out.println("Insufficient Funds");
            throw new IllegalArgumentException();
        }    }

    @Override
    public void withdrawal(Double amountToDecreaseBy) {
        try {
            if(val >= amountToDecreaseBy && amountToDecreaseBy > 0) {
                val -= amountToDecreaseBy;
            }else{
                throw new IllegalArgumentException();
            }
        }catch (IllegalArgumentException e){
            System.out.println("Insufficient Funds");
            throw new IllegalArgumentException();
        }
    }

    @Override
    public Double getBalance() {
        return val;
    }
}
